------------------------------------------------------------------
--FCONoEnlightenedSound.lua
--Author: Baertram
--v0.0.4
--[[
Removes the played sound when you get enlightened
]]
------------------------------------------------------------------
--Array for all the variables
local locVars = {}
locVars.AddMessage_Orig = nil

--Addon variables
local addonVars = {}
addonVars.gAddonName				= "FCONoEnlightenedSound"
addonVars.addonAuthor 				= '|cFFFF00Baertram|r'
addonVars.addonVersion		   		= 0.01 -- Changing this will reset SavedVariables!
addonVars.addonVersionOptions 		= '0.0.4' -- version shown in the settings panel
addonVars.addonSavedVariablesName	= "FCONoEnlightenedSound_Settings"

--==============================================================================
--==================== START EVENT CALLBACK FUNCTIONS===========================
--==============================================================================

--New function for the AddMessage at a center screen announcement
local function FCONoEnlightenedSound_AddMessage_Hook(self, eventId, category, soundId, ...)
    if (eventId == EVENT_PLAYER_ACTIVATED and soundId == SOUNDS.ENLIGHTENED_STATE_GAINED) then
        soundId = nil
    end
    locVars.AddMessage_Orig(self, eventId, category, soundId, ...)
end

-- Fires each time after addons were loaded and player is ready to move (after each zone change too)
local function FCONoEnlightenedSound_Player_Activated(...)
	--Backup the real ultimate ready sound
	SOUNDS.ENLIGHTENED_STATE_GAINED_FCO = SOUNDS.ENLIGHTENED_STATE_GAINED
	--Remove the enlightened sound
	SOUNDS.ENLIGHTENED_STATE_GAINED = SOUNDS.NONE
end

local function  FCONoEnlightenedSound_Addon_Loaded(eventCode, addOnName)
	--Is THIS addon HERE found?
    if(addOnName ~= "FCONoEnlightenedSound") then
        return
    end

	--Backup the original AddMessage function of the center screen announcements
	locVars.AddMessage_Orig = CENTER_SCREEN_ANNOUNCE.AddMessage
	--Replace it with a new function now
	CENTER_SCREEN_ANNOUNCE.AddMessage = FCONoEnlightenedSound_AddMessage_Hook

    --If you got here your addon is found so execute the following code lines:
    --Unregister this event again so it isn't fired again after this addon has beend loaded
    EVENT_MANAGER:UnregisterForEvent(addonVars.gAddonName, EVENT_ADD_ON_LOADED)
	--Register for the zone change/player ready event
	EVENT_MANAGER:RegisterForEvent(addonVars.gAddonName, EVENT_PLAYER_ACTIVATED, FCONoEnlightenedSound_Player_Activated)
end

-- Register the event "addon loaded" for this addon
local function FCONoEnlightenedSound_Initialized()
	--Register for the addon loaded
	EVENT_MANAGER:RegisterForEvent(addonVars.gAddonName, EVENT_ADD_ON_LOADED, FCONoEnlightenedSound_Addon_Loaded)
end

--------------------------------------------------------------------------------
--- Call the start function for this addon to register events etc.
--------------------------------------------------------------------------------
FCONoEnlightenedSound_Initialized()
